#include "xfsp.h"
#include "patchlevel.h"

Display *dpy;
int screen_num;
static char *progname;
char *dpy_name = NULL;
char *geom = NULL;
char *fontname = "fixed";
char hostname[40], portname[6], lfilname[30], rdirname[70] ,rfilname[30];
char currdir[70], dates[256][20], sizes[256][10], names[256][50];
char home[60], hostf[40], vers[40];
int  dirs[256], dirlen = 1, entries, topent, hoston = 0, numhosts, tophost;

Window win, hostwin, aboutwin;
XEvent event;
XSetWindowAttributes xswa;
XTextProperty WinName, IconName;
XFontStruct *font;
GC gc;
unsigned long bg, fg;
XButtonEvent *buteven;
XExposeEvent *expose;
Pixmap down, up, maxdown, maxup, logo;
int ddepth, litbutton, litstr;

void makepix(), mainscr(), keyhandler(); 

int main(argc, argv)
int argc;
char **argv;
{
unsigned int dwidth, dheight, swidth, sheight, bwidth;
int x, y;

 progname = argv[0];
 while (*++argv) {
  if (!strncmp(*argv, "-disp", 5)) dpy_name = *++argv;
   else
  if (!strncmp(*argv, "-geo", 4)) geom = *++argv;
  }
 if ((dpy = XOpenDisplay(dpy_name)) == NULL) {
  printf("Can not connect to DISPLAY : %s\n", dpy_name);
  exit(-1);
 }
 screen_num = DefaultScreen(dpy);
 dwidth  = DisplayWidth(dpy, screen_num);
 dheight = DisplayHeight(dpy, screen_num);
 ddepth = DefaultDepth(dpy, screen_num);
 swidth = 500;
 sheight = 400;
 x = y = 0;
 bg = WhitePixel(dpy, screen_num);
 fg = BlackPixel(dpy, screen_num);
 if (geom) XParseGeometry(geom, &x, &y, &swidth, &sheight);
 xswa.event_mask =   ExposureMask | KeyPressMask |
                     ButtonPressMask | ButtonReleaseMask;
 xswa.background_pixel = bg;
 xswa.border_pixel = fg;
 win = XCreateWindow(dpy, DefaultRootWindow(dpy), 0, 0, swidth, sheight, 0,
       ddepth, InputOutput, DefaultVisual(dpy, DefaultScreen(dpy)),
       CWEventMask | CWBackPixel | CWBorderPixel, &xswa);
 strcpy(vers,"XFSP - Version ");
 strcat(vers,VERSION);
 XChangeProperty(dpy, win, XA_WM_NAME, XA_STRING, 8, PropModeReplace,
                 vers, strlen(vers));
 if ((font = XLoadQueryFont(dpy, fontname)) == NULL) {
  printf("Couldn't open the FIXED font.\n");
  exit(-1);
 }
 gc = XCreateGC(dpy, RootWindow(dpy, screen_num), 0, NULL);
 XSetForeground(dpy, gc, fg);
 XSetBackground(dpy, gc, bg);
 XMapWindow(dpy, win);
 makepix();
 homedir();
 strcpy(hostf,home);
 strcat(hostf,"/.fhosts");
 readhosts();
 strcpy(rdirname,"/");
 strcpy(currdir,"/");
 while (1) {
  XNextEvent(dpy, &event);
  switch (event.type) {
  case Expose:
    expose = (XExposeEvent *) &event;
    if (expose->window == win) mainscr();
    if (expose->window == hostwin) hostscr();
    if (expose->window == aboutwin) aboutscr();
    break;
  case ButtonPress:
    buttonhandler(event.xbutton.x, event.xbutton.y, event.xbutton.window, 1);
    break;
  case ButtonRelease:
    buttonhandler(event.xbutton.x, event.xbutton.y, event.xbutton.window, 0);
    break;
  case KeyPress:
    keyhandler();
    break;
  default:
    break;
  }
 }
}
